/*
 *
 *                         DES SOFTWARE PACKAGE
 *                             Version 2.2
 *
 *                                        _
 * Copyright (c) 1990,1991,1992,1993 Stig Ostholm.
 * All Rights Reserved
 *
 *
 * The author takes no responsibility of actions caused by the use of this
 * software package and does not guarantee the correctness of the functions.
 *
 * This software package may be freely distributed for non-commercial purpose
 * as long as the copyright notice is kept. Any changes made should be
 * accompanied by a comment indicating who made the change, when it was made
 * and what was changed.
 *
 * This software package, or any parts of it, may not be used or in any way
 * re-distributed for commercial purpose without the authors permission.
 * The author keeps the right to decide between of what is commercial and
 * what is non-commercial purpose.
 *
 * Restrictions due to national laws governing the use, import or export of
 * cryptographic software is the responsibility of the software user/importer/
 * exporter to follow.
 *
 *
 *                                              _
 *                                         Stig Ostholm
 *                                         Chalmers University of Technology
 *                                         Department of Computer Engineering
 *                                         S-412 96 Gothenburg
 *                                         Sweden
 *                                         ----------------------------------
 *                                         Email: ostholm@ce.chalmers.se
 *                                         Phone: +46 31 772 1703
 *                                         Fax:   +46 31 772 3663
 */

#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<des.h>
#include	"env.h"
#include	"core.h"
#include	"config.h"
#include	"version.h"


/*
 * `getcore'
 *
 *	This function searches the `core_tab' for requested `name'
 *	data.
 */

core_mode	*getcore(
#ifdef __SDTC__
	char	*name)
#else
	name)
char	*name;
#endif
{
	register int	i;


#ifdef DES_CORE
	if (name == (char *) 0)
		name = getenv(DES_CORE);
#endif /* DES_CORE */
	if (name != (char *) 0) {
		for (i = 0; name[i]; i++)
			if (islower((int) name[i]))
				name[i] = (char) toupper((int) name[i]);
	
		for (i = 0; core_list[i].name; i++)
			if (!strcmp(name, core_list[i].name))
				return &core_list[i];

		return (core_mode *) 0;
	}

	return (core_mode *) &core_list[0];
}
